#include "tab.h"
#include<stdio.h>
#include<math.h>

/* wczytuje 'n' liczb rzeczywistych do tablicy 't[]'.
 * Wartoscia zwracana jest adres tablicy 't[]' */
float *wczytaj(float *t, int n)
{
	int i;
	float *poczatek=t;

	printf("\nPodaj kolejne liczby:\n");

	for(i=0;i<n;i++)
	{
		printf("tab[%d]=",i);
		scanf("%f",&t[i]);
	}
	return poczatek;
}

/* Funkcja wyswietla na ekranie 'n' pierwszych liczb rzeczywistych zawartych w tablicy 't[]' */
void wyswietl(float t[], int n)
{
	int i;
	for(i=0;i<n;i++)
	{
		printf("tab[%d]=%f\n",i,t[i]);
	}
}

/* Funkcja oblicza wartosc srednia z 'n' pierwszych liczb umieszczonych w tablicy 't[]'.  */
float srednia(float t[], int n)
{
	int i;
	float s=0;
	for(i=0;i<n;i++)
	{
		s=s+t[i];
	}
	return s/n;
}

/* Funkcja oblicza odleglosc euklidesowa dwoch wektorow 'n' wymiarowych.
 * Argumenty 'a' i 'b' zawieraja wspolczynniki wektorow.
 */
float odleglosc(float a[], float b[], int n)
{
	int i;
	float o=0;
	for(i=0;i<n;i++)
	{
		o=o+pow(a[i]-b[i],2);
	}
	return sqrt(o);
}

/* Funcka sortuje ementy tablicy 't[]' za pomoca algorytmu babelkowego.
 * Argument 'n' reprezentuje liczbe elementow w tablicy.
 * Wartoscia zwracana jest wskaznik do posortowanej tablicy. */
float* sort(float *t, int n)
{
	int i;
	float o;

	for(i=0;i<n-1;i++)
	{
		if (t[i+1]<t[i])
		{
			o=t[i+1];
			t[i+1]=t[i];
			t[i]=o;
			i=-1;
		}
	}
	return t;
}

/* Funckja znajduje w tablicy 'tab[]' element o najwiekszej wartosci.
 * Wartoscia zwracana jest pozycja elementu o najwiekszej wartosci.   */
int maxind(float tab[], int n)
{
	int i;
	int max=0;
    for(i=1;i<n;i++)
	{
		if (tab[i]>tab[max])
			max=i;
	}
	return max;
}

/* Funcka sortuje lementy tablicy 't[]' za pomoca metody przez wybor elementu maksymalnego (insert sort).
 * Argument 'n' reprezentuje liczbe elementow w tablicy.
 * Wartoscia zwracana jest wskaznik do posortowanej tablicy. */
float* insertsort(float tab[], int n)
{
	int i;
	int max=0;
	float mem;
	for(i=n;i>0;i--)
	{
		max=maxind(tab,i);
		mem=tab[i-1];
		tab[i-1]=tab[max];
		tab[max]=mem;
	}
	return tab;
}

/* Funkcja odwraca kolejnosc (pierwszych 'n') elementow w tablicy 'tablica[]'.
 * Wartoscia zwracana jest adres tablicy 'tablica[]' z odwroconymi elementami. */
float * odwroc(float *tablica, int n)
{
    float *p, *k;
    float t;

    p = tablica;
    k = tablica + n -1;

    while(p<k)
    {
       t = *p;
       *p = *k;
       *k = t;
       *p++;
       *k--;
    }
    return tablica;
}
